function main = saveres
close all;
filenum = 10;
ims=readfiles(filenum);
bins = 256;
for imbase = 1:filenum
    imi=ims(:,:,:,imbase);
    for k=1:filenum
       imk=ims(:,:,:,k);
       res(1,k,imbase)=imdiff1(imi,imk,bins);
       res(2,k,imbase)=imdiff2(imi,imk,bins);
       res(3,k,imbase)=imdiff3(imi,imk,bins);
       res(4,k,imbase)=imdiff4(imi,imk,bins);
       res(5,k,imbase)=imdiff5(imi,imk,bins);
    end;
    for method_k = 1:5
        [y,ind(method_k,:,imbase)]=sort(res(method_k,:,imbase));
        for file_k = 1:filenum
             ord(method_k,ind(method_k,file_k,imbase),imbase)=file_k;
        end;
    end;
end;
save myresult ims ind ord
return;


function rf = readfiles(filenum)
for i = 0:filenum-1
    if i<10
        stra=strcat('0',int2str(i),'.jpe');
    else
        stra=strcat(int2str(i),'.jpe');
    end

    ima=imread(stra);
    ima=imresize(ima,[80,112]);
    I(:,:,:,i+1)=ima;
end
rf=I;
return;


function imd1 = imdiff1(A,B,bins)
sum = 0;
for k=1:3
    ya = imhist(A(:,:,k),bins);
    yb = imhist(B(:,:,k),bins);
    diff = vdiff1(ya', yb');
    sum = sum+diff;
end
imd1 = sum ;
return;

function imd2 = imdiff2(A,B,bins)
sum = 0;
for k=1:3
    ya = imhist(A(:,:,k),bins);
    yb = imhist(B(:,:,k),bins);
    diff = vdiff2(ya', yb');
    sum = sum+diff;
end
imd2 = sum ;
return;

function imd3 = imdiff3(A,B,bins)
sum = 0;
for k=1:3
    ya = imhist(A(:,:,k),bins);
    yb = imhist(B(:,:,k),bins);
    diff = vdiff3(ya', yb');
    sum = sum+diff;
end
imd3= sum ;
return;

function imd4 = imdiff4(A,B,bins)
sum = 0;
for k=1:3
    ya = imhist(A(:,:,k),bins);
    yb = imhist(B(:,:,k),bins);
    diff = vdiff4(ya', yb');
    sum = sum+diff;
end
imd4= sum;
return;


function imd5 = imdiff5(A,B,bins)
sum = 0;
for k=1:3
    ya = imhist(A(:,:,k),bins);
    yb = imhist(B(:,:,k),bins);
    diff = vdiff5(ya', yb');
    sum = sum+diff;
end
imd5= sum;
return;

function sqrtsumsqrdiff = vdiff1(v1,v2)
v3=v1-v2; v3=v3.^2;
sqrtsumsqrdiff = sqrt(sum(v3));
return;

function sumabsdiff  = vdiff2(v1,v2)
v4=abs(v1-v2);
sumabsdiff = sum(v4);
return;

function  sumsqrdiff = vdiff3(v1,v2)
v5=v1-v2; v5=v5.^2;
sumsqrdiff = sum(v5);
return;

function staticsdiff = vdiff4 (v1,v2)
v6=abs(v1-v2); 
average=mean(v6);
v7= v6- average;
v7=v7.^2;
[x,y]=size(v7);
stdiff=sum(v7)/(y-1);
if stdiff == 0
    staticsdiff = 0;
else
    spd=sqrt(y)*average/sqrt(stdiff);
    staticsdiff = abs(spd);
end;
return;


function muldiff= vdiff5(v1,v2)
vdot = v1*v2';
vnorm = norm(v1)* norm(v2);
muldiff = 1-(vdot/vnorm);
return;

